import 'package:example/state.sealed.dart';
import 'package:like_sealed/like_sealed.dart';

@likeSealed
abstract class State {}

class InitState extends State {
  InitState();
}

class DataState extends State {
  final String message;

  DataState(this.message);
}

class ProgressState extends State {
  final Future future;
  final String arg;
  final String argg;
  final String arggg;

  ProgressState(this.future, [this.arg, this.argg, this.arggg]);
}

class NamedState extends State {
  final String arg;
  final String argg;
  final String arggg;

  NamedState()
      : arg = null,
        arggg = null,
        argg = null;

  NamedState.named(this.arg, {this.argg, this.arggg});
}
