import 'package:example/state.dart';
import 'package:example/state.sealed.dart';

main() {
  State state = States.dataState("Nice");
  final switchImpl = StateSwitchImpl(
    state: (s) => s.toString(),
  );
  print(switchImpl.switchCase(state));
  SampleBloc().add(state);
}

class SampleBloc with StateSwitch<dynamic> {
  add(State state) {
    switchCase(state);
  }

  @override
  onDataState(DataState dataState) {
    print(dataState.message);
  }

  @override
  onInitState(InitState initState) {
    // TODO: implement onInitState
    return null;
  }

  @override
  onProgressState(ProgressState progressState) {
    // TODO: implement onProgressState
    return null;
  }

  @override
  onDefault(State state) {
    // TODO: implement onDefault
    return null;
  }

  @override
  onNamedState(NamedState namedState) {
    // TODO: implement onNamedState
    return null;
  }
}
